【HDU-1808】解题报告(数论,鸽巢定理)

原始题目

Halloween treats

  • Time Limit: 1000/1000 MS (Java/Others)
  • Memory Limit: 32768/32768 K (Java/Others)
  • Total Submission(s): 1366
  • Accepted Submission(s): 560
  • Special Judge

Problem Description

Every year there is the same problem at Halloween: Each neighbour is only willing to give a certain total number of sweets on that day, no matter how many children call on him, so it may happen that a child will get nothing if it is too late. To avoid conflicts, the children have decided they will put all sweets together and then divide them evenly among themselves. From last year's experience of Halloween they know how many sweets they get from each neighbour. Since they care more about justice than about the number of sweets they get, they want to select a subset of the neighbours to visit, so that in sharing every child receives the same number of sweets. They will not be satisfied if they have any sweets left which cannot be divided.

Your job is to help the children and present a solution.

Input

The input contains several test cases.

The first line of each test case contains two integers c and n (1 ≤ c ≤ n ≤ 100000), the number of children and the number of neighbours, respectively. The next line contains n space separated integers a1 , ... , an (1 ≤ ai ≤ 100000 ), where ai represents the number of sweets the children get if they visit neighbour i.

The last test case is followed by two zeros.

Output

For each test case output one line with the indices of the neighbours the children should select (here, index i corresponds to neighbour i who gives a total number of ai sweets). If there is no solution where each child gets at least one sweet, print "no sweets" instead. Note that if there are several solutions where each child gets at least one sweet, you may print any of them.

Sample Input

4 5
1 2 3 7 5
3 6
7 11 2 5 13 17
0 0

Sample Output

3 5
2 3 4

Source

HDOJ 2007 Summer Exercise(1)

Recommend

linle

题目大意

题目大意,万圣节孩子们去要糖果。给定孩子数\(c\),和邻居数\(n\),且\(n>c\)。每个邻居家里有糖果\(a_i\),孩子们希望能 找到一些家庭他们的糖果数恰好时能被\(c\)整除,问是否存在,不存在输出“no sweets”,存在的话输出邻居的编号。

解题思路

由于\(n>c\),求前缀和数组sum,对于严格单调增的n个前缀和,由于鸽巢原理,必然存在至少两个模c同余。

解题代码